var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp, _initialiseProps;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import _ from 'lodash';
import schema from "async-validator";
import { Form, Icon, Button, Input } from 'antd';
import PureRender from '../decorator/PureRender';
import ItemButtonGroupDecorator from '../decorator/ItemButtonGroup';
import util from '../util';

var FormItem = Form.Item;

/**
 * 所有表单组件的公共处理部分
 * @prop { string } type 组件类型 
 * @prop { string } name 跟原生的html一样，同时async-validator要用到（表单验证），取值要用到，要唯一。 
 * @prop { array } rules 参考 async-validatord的rules。
 * @prop { object } formItemProps 跟antd的Form.Item的props完全一致，请参考Form.Item，这个不经常使用。
 */

var BasicItem = PureRender(_class = ItemButtonGroupDecorator(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(BasicItem, _React$Component);

  function BasicItem(props) {
    _classCallCheck(this, BasicItem);

    var _this = _possibleConstructorReturn(this, (BasicItem.__proto__ || Object.getPrototypeOf(BasicItem)).call(this, props));

    _initialiseProps.call(_this);

    _this.state = {
      errors_type: "",
      errors_message: ""
    };
    //console.debug(this.context)
    _this.validate(_this.props, true);
    return _this;
  }

  _createClass(BasicItem, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.bindValidate(this.props);
      this.bindSetFieldValue(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.bindValidate(nextProps);
      this.bindSetFieldValue(nextProps);
      this.validate(nextProps);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      //销毁时，删除验证函数
      if (this.context.itemsValidateFunc) {
        delete this.context.itemsValidateFunc[this.key];
      }
    }

    /**
    * 公共验证方法
    * @param { object } props 当前组件props或结构差不多的object对象 
    */

  }, {
    key: 'bindValidate',
    value: function bindValidate(props) {
      var name = props.name,
          uniqueKey = props.uniqueKey;

      if (this.key) {
        if (this.context.itemsValidateFunc) {
          delete this.context.itemsValidateFunc[this.key];
        }
      }
      if (uniqueKey) {
        this.key = name + "-" + uniqueKey;
      } else {
        this.key = name;
      }
      if (this.context.itemsValidateFunc) {
        this.context.itemsValidateFunc[this.key] = this.commonValidate(props);
      }
      //console.debug(this.context)
    }
  }, {
    key: 'bindSetFieldValue',
    value: function bindSetFieldValue(props) {
      var _this2 = this;

      if (this.context.setFieldValueFunc) {
        this.context.setFieldValueFunc[props.name] = function (value) {
          props.storage.value = value;
          _this2.setState({
            random: util.getUniqueKey()
          });
          _this2.setArrayValue = true;
          _this2.validate(props);
        };
      }
    }

    /**
    * 当前表单组件验证，并提示
    * @param { object } props 当前组件props 
    * @param { boolean } isConstructor 是否是当类构造器（构造函数实例化后只运行一次） 
    */

  }, {
    key: 'validate',
    value: function validate(props, isConstructor) {
      var _this3 = this;

      var name = props.name,
          storage = props.storage,
          value = props.value,
          rules = props.rules,
          validateAll = props.validateAll;

      if ((storage.value === undefined || storage.value === null) && !validateAll) {
        return;
      }
      this.commonValidate(props)(function (errors) {
        //验证失败
        var message = "";
        errors.forEach(function (v, k) {
          if (k !== 0) {
            message += "，" + v.message;
          } else {
            message += v.message;
          }
        });
        var obj = {
          errors_type: "error",
          errors_message: message
        };
        if (!isConstructor) {
          _this3.setState(obj);
        } else {
          _this3.state = obj;
        }
      }, function (fields) {
        //验证成功
        var obj = {
          errors_type: "success",
          errors_message: ""
        };
        if (isConstructor) {
          _this3.state = obj;
        } else {
          _this3.setState(obj);
        }
      });
    }
  }, {
    key: 'getDealProp',
    value: function getDealProp(props, index, defaultValue) {
      if (props[index] === undefined) {
        if (this.context[index]) {
          props[index] = this.context[index];
        } else {
          props[index] = defaultValue;
        }
      }
    }
  }, {
    key: 'addOtherPropsFromFormBuilder',
    value: function addOtherPropsFromFormBuilder(props) {
      this.getDealProp(props, "size", "default");
      return props;
    }
  }, {
    key: 'addFormItemPropsFromFormBuilder',
    value: function addFormItemPropsFromFormBuilder(props) {
      this.getDealProp(props, "hasFeedback", false);
      this.getDealProp(props, "labelCol", null);
      this.getDealProp(props, "wrapperCol", null);
      return props;
    }
  }, {
    key: 'renderArrayItem',
    value: function renderArrayItem() {
      var _this4 = this;

      var _props = this.props,
          storage = _props.storage,
          label = _props.label,
          type = _props.type;

      if (this.props.array && type !== "select" && type !== "multiple-select") {
        if (!storage.arrayProps) {
          var obj;
          storage.arrayProps = [];
          if (_.isString(this.props.storage.value) || !this.props.storage.value) {
            obj = _.cloneDeep(this.props);
            obj.key = util.getUniqueKey();
            storage.arrayProps = [obj];
          } else if (_.isArray(this.props.storage.value)) {
            storage.value.forEach(function (v, k) {
              obj = _.cloneDeep(_this4.props);
              obj.key = util.getUniqueKey();
              obj.value = v;
              obj.storage = {
                value: v
              };
              storage.arrayProps.push(obj);
            });
          }
        } else {
          if (this.setArrayValue) {
            storage.arrayProps.forEach(function (v, k) {
              v.value = storage.value[k];
              v.storage.value = storage.value[k];
            });
            this.setArrayValue = false;
          }
        }
        return React.createElement(
          'span',
          null,
          storage.arrayProps.map(function (v, k) {
            //v.storage.value = undefined;
            var className = "array-item-none-label";
            if (label) {
              className = "array-item-has-label";
            }
            if (k !== 0) {
              className = "array-item-none-label";
            }
            return React.createElement(
              'div',
              { key: v.key, className: className + " clearfix" },
              React.createElement(
                'div',
                { className: 'array-item-con' },
                React.createElement(
                  'div',
                  { className: 'array-item-left' },
                  React.createElement(BasicItem, _extends({}, v, {
                    name: v.name + '[' + k + ']',
                    array: false
                  }))
                ),
                React.createElement(
                  'div',
                  { className: 'array-item-right' },
                  React.createElement(
                    'div',
                    null,
                    _this4.buttonGroupAdapter({
                      up_action: true,
                      down_action: true,
                      delete_action: true
                    }, k, storage.arrayProps)
                  )
                )
              ),
              k === storage.arrayProps.length - 1 && React.createElement(
                Button,
                {
                  type: 'primary',
                  className: 'array-item-add-btn fr',
                  onClick: _this4.onAddClick(storage.arrayProps, k)
                },
                React.createElement(Icon, { type: 'plus' })
              )
            );
          })
        );
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;

      var min = props.min,
          max = props.max,
          onlyLetter = props.onlyLetter,
          validateAll = props.validateAll,
          array = props.array,
          uniqueKey = props.uniqueKey,
          label = props.label,
          storage = props.storage,
          children = props.children,
          _props$rules = props.rules,
          rules = _props$rules === undefined ? [] : _props$rules,
          value = props.value,
          targetComponent = props.targetComponent,
          _props$formItemProps = props.formItemProps,
          formItemProps = _props$formItemProps === undefined ? {} : _props$formItemProps,
          other = _objectWithoutProperties(props, ['min', 'max', 'onlyLetter', 'validateAll', 'array', 'uniqueKey', 'label', 'storage', 'children', 'rules', 'value', 'targetComponent', 'formItemProps']);

      other = this.addOtherPropsFromFormBuilder(other);
      formItemProps = this.addFormItemPropsFromFormBuilder(formItemProps);
      //渲染array类型的Item
      var arrayItem = this.renderArrayItem();
      if (arrayItem) {
        return arrayItem;
      }
      //消除原生表单required属性的影响
      delete other.required;
      var FormItemComponent = targetComponent;
      var component;
      if (!FormItemComponent) {
        return false;
      } else if (children) {
        //可以传子组件进来，像Select的option等
        component = React.createElement(
          FormItemComponent,
          _extends({}, other, {
            value: storage.value,
            onChange: this.onChange(rules)
          }),
          children
        );
      } else {
        var temp_name;
        if (other.type !== "timepicker") {
          temp_name = other.name;
        }
        component = React.createElement(FormItemComponent, _extends({}, other, {
          name: temp_name,
          value: storage.value,
          onChange: this.onChange(rules)
        }));
      }

      if (other.type === "hidden") {
        return component;
      }
      var required = false;
      rules.forEach(function (v) {
        if (v.required) {
          required = true;
        }
      });
      //console.debug(other.name,this.state.errors_type)
      //console.debug(other.name,rules)
      var errors_type = this.state.errors_type;
      if (!rules[0]) {
        errors_type = null;
      }
      return React.createElement(
        'span',
        null,
        React.createElement(
          FormItem,
          _extends({}, formItemProps, {
            required: required,
            validateStatus: errors_type,
            help: this.state.errors_message
          }),
          component
        ),
        (other.type === "radiogroup" || other.type === "select") &&
        //处理timepicker这种，无法设置name的表单组件
        React.createElement(Input, {
          type: 'hidden',
          name: other.name,
          value: storage.value
        }),
        (other.type === "monthpicker" || other.type === "timepicker" || other.type === "datepicker") &&
        //处理timepicker这种，无法设置name的表单组件
        React.createElement(Input, {
          type: 'hidden',
          name: other.name,
          value: storage.value && Math.floor(+storage.value / 1000)
        }),
        other.type === "rangepicker" && storage.value && storage.value.map(function (v, k) {
          return React.createElement(
            'span',
            { key: k },
            React.createElement(Input, {
              type: 'hidden',
              name: other.name,
              value: v && Math.floor(+v / 1000)
            })
          );
        }),
        (other.type === "cascader" || other.type === "multiple-select" || other.type === "checkboxgroup") && storage.value && storage.value.map(function (v, k) {
          return React.createElement(
            'span',
            { key: k },
            React.createElement(Input, {
              type: 'hidden',
              name: other.name,
              value: v
            })
          );
        })
      );
    }
  }]);

  return BasicItem;
}(React.Component), _class2.propTypes = {
  type: React.PropTypes.string,
  rules: React.PropTypes.array,
  name: React.PropTypes.string,
  formItemProps: React.PropTypes.object
}, _class2.contextTypes = {
  form: React.PropTypes.object,
  size: React.PropTypes.string,
  hasFeedback: React.PropTypes.bool,
  labelCol: React.PropTypes.object,
  wrapperCol: React.PropTypes.object,
  inline: React.PropTypes.bool,
  itemsValidateFunc: React.PropTypes.object,
  setFieldValueFunc: React.PropTypes.object
}, _initialiseProps = function _initialiseProps() {
  var _this5 = this;

  this.commonValidate = function (props) {
    var name = props.name,
        storage = props.storage,
        rules = props.rules,
        type = props.type;
    //console.debug("dddd",name,storage)

    return function (errorCallback, successCallback) {
      if (!rules || rules && !rules[0]) {
        return false;
      }
      var descriptor = {};
      descriptor[name] = rules;
      var validator = new schema(descriptor);
      var obj = {};
      switch (type) {
        case "number":
        case "float":
        case "integer":
          if (storage.value) {
            obj[name] = Number(storage.value);
          }
          break;
        default:
          obj[name] = storage.value;
      }
      //console.debug(obj[name])
      validator.validate(obj, function (errors, fields) {
        if (errors) {
          errorCallback && errorCallback(errors, _this5);
        } else {
          //console.debug(fields)
          successCallback && successCallback(fields);
        }
      });
    };
  };

  this.onChange = function (rules) {
    return function (e) {
      var value;
      if (e && e.target) {
        value = e.target.value;
      } else {
        value = e;
      }
      _this5.setState({
        random: util.getUniqueKey()
      });
      //console.debug(value)
      if (_this5.props.storage) {
        _this5.props.storage.value = value;
      }
      //console.debug(rules)
      if (rules[0]) {
        _this5.validate(_this5.props);
      }
      //console.debug(value,this.props)
      _this5.props.onChange && _this5.props.onChange(e);
    };
  };

  this.onButtonChange = function (data, index) {
    return function (btn_index) {
      switch (btn_index) {
        case "up":
          util.swapArrayItem(data, index, index - 1);
          break;
        case "down":
          util.swapArrayItem(data, index, index + 1);
          break;
        case "delete":
          //console.debug(data,index)
          data.splice(index, 1);
          break;
      }
      _this5.setState({
        random: util.getUniqueKey()
      });
    };
  };

  this.onAddClick = function (data, index) {
    return function (e) {
      var index_data = _.cloneDeep(data[index]);
      index_data.key = util.getUniqueKey();
      index_data.storage = {};
      data.splice(index + 1, 0, index_data);
      _this5.setState({
        random: util.getUniqueKey()
      });
    };
  };
}, _temp)) || _class) || _class;

export default BasicItem;