var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PropTypes } from 'react';
import ReactDOM from 'react-dom';
import schema from "async-validator";
import _ from 'lodash';
import serialize from "form-serialize";
import Form from 'antd/lib/form';
import BuilderDecorator from '../../decorator/Builder';
import util from "../../util";
import FormBuilderWidthConfig from "./FormBuilderWidthConfig";
/**
 * SimpleFormBuilder 
 * @prop {String} size size 设置表单子项（包括antd Input、Select等和FormItem）size，表单子项size优先级更高。
 * @prop {Boolean} hasFeedback 表单验证在antd的FormItem验证是否反馈，单个针对设置优先级更高。 
 * @prop {object} labelCol 跟antd的Form.Item prop.labelCol完全一致，这里是统一设置，单个针对设置优先级更高。 
 * @prop {object} wrapperCol 跟antd的Form.Item prop.wrapperCol完全一致，这里是统一设置，单个针对设置优先级更高。 
 * @prop {Object} config FormBuilder 配置项，表单就是从这些配置中渲染出来的 （可选） 
 * @prop {array} selectSourceData 下拉数据源 
 * @inherit props继承所有的Antd.Form的props 
 */

var FormBuilder = BuilderDecorator(_class = function (_React$Component) {
  _inherits(FormBuilder, _React$Component);

  function FormBuilder(props) {
    _classCallCheck(this, FormBuilder);

    var _this = _possibleConstructorReturn(this, (FormBuilder.__proto__ || Object.getPrototypeOf(FormBuilder)).call(this, props));

    _this.state = {};
    //存放各个表单项设置value的方法
    _this.setFieldValueFunc = {};
    //表单各个输入组件验证方法存储
    _this.itemsValidateFunc = {};
    //表单错误信息存放
    _this.errors = [];
    //是否验证全部表单（提交表单时用到）
    _this.validateAll = false;
    return _this;
  }

  _createClass(FormBuilder, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var formDom = ReactDOM.findDOMNode(this.refs.formBuilder);
      if (!this.context.formBuilder) {
        return;
      }
      this.context.formBuilder.setFieldsValue = function (values) {
        for (var k in values) {
          _this2.setFieldValueFunc[k] && _this2.setFieldValueFunc[k](values[k]);
        }
      };
      this.context.formBuilder.validateFields = function (callback) {
        _this2.errors = [];
        //表单验证
        for (var k in _this2.itemsValidateFunc) {
          _this2.itemsValidateFunc[k](function (errors, currentFormItem) {
            //console.debug(k)
            _this2.errors.push(errors);
            //使用jsx style组件，特殊处理
            if (!_this2.props.config) {
              var message = "";
              errors.forEach(function (v, k) {
                if (k !== 0) {
                  message += "，" + v.message;
                } else {
                  message += v.message;
                }
              });
              var obj = {
                errors_type: "error",
                errors_message: message
              };
              currentFormItem.setState(obj);
            }
          });
        }
        var values = serialize(formDom, { hash: true });
        if (_this2.errors[0]) {
          _this2.setState({
            random: util.getUniqueKey(),
            validateAll: true
          });
          callback(_this2.errors, values);
        } else {
          callback(null, values);
        }
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          form = _props.form,
          size = _props.size,
          config = _props.config,
          hasFeedback = _props.hasFeedback,
          labelCol = _props.labelCol,
          wrapperCol = _props.wrapperCol,
          className = _props.className,
          selectSourceData = _props.selectSourceData,
          other = _objectWithoutProperties(_props, ['form', 'size', 'config', 'hasFeedback', 'labelCol', 'wrapperCol', 'className', 'selectSourceData']);

      other.className = className + " builder-con";
      return React.createElement(
        Form,
        _extends({}, other, { ref: 'formBuilder' }),
        config && React.createElement(FormBuilderWidthConfig, {
          config: config,
          random: this.state.random,
          validateAll: this.state.validateAll
        }),
        this.props.children
      );
    }
  }]);

  return FormBuilder;
}(React.Component)) || _class;

export default FormBuilder;