var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PropTypes } from 'react';
import _ from 'lodash';
import Modal from 'antd/lib/modal';
import Table from 'antd/lib/table';
import Icon from 'antd/lib/icon';
import util from "../../util";
import PureRender, { shallowCompare } from "../../decorator/PureRender";
import localeDecorator from "../../decorator/Locale";
import AddAndUpdateForm from "./components/AddAndUpdateForm";
import localeText from './en_US';
/**
 * FormBuilder config 配置器 
 *@prop { string } title 第一级table的title
 *@prop { object } config 配置数据，只要config改变了都会以新的config重新渲染（父组件传进来） 
 *@prop { function } onChange 配置数据变化时触发的回调函数（这里的配置数据与父组件传进来的是相互独立的） 
 *   function(data01,data02)，data01是formBuilderConfiger的配置数据，data02是formBuilder的配置数据
 *@prop { boolean } hasNoneTableTitle table title是否显示,默认true 
 *@prop { array } selectSourceDataMap 拉选择数据源 
 *@prop { object } fieldAddedOperation 添加字段的按钮或图标（react组件） 
 *@prop { boolean } canNotDeleteFunction 开启不可删除选项 
 *@prop { boolean } readOnlyFunction 开启只读选项 
 */

var FormBuilderConfiger = localeDecorator(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(FormBuilderConfiger, _React$Component);

  _createClass(FormBuilderConfiger, null, [{
    key: 'create',
    value: function create() {
      var _class3, _temp2;

      var Decorator = (_temp2 = _class3 = function (_React$Component2) {
        _inherits(Decorator, _React$Component2);

        function Decorator(props) {
          _classCallCheck(this, Decorator);

          var _this2 = _possibleConstructorReturn(this, (Decorator.__proto__ || Object.getPrototypeOf(Decorator)).call(this, props));

          _this2.formBuilderConfiger = {};
          return _this2;
        }

        _createClass(Decorator, [{
          key: 'getChildContext',
          value: function getChildContext() {
            return {
              formBuilderConfiger: this.formBuilderConfiger
            };
          }
        }, {
          key: 'render',
          value: function render() {
            var _this3 = this;

            this.formBuilderConfiger.openAddFieldDialogEvent = function (e) {
              _this3.formBuilderConfiger.openAddFieldDialog(e);
            };
            var WrapperComponent = this.getWrapperComponent();
            return React.createElement(WrapperComponent, _extends({}, this.props, {
              formBuilderConfiger: this.formBuilderConfiger
            }));
          }
        }]);

        return Decorator;
      }(React.Component), _class3.childContextTypes = {
        formBuilderConfiger: PropTypes.object.isRequired
      }, _temp2);

      return function (WrappedComponent) {
        function getDisplayName(WrappedComponent) {
          return WrappedComponent.displayName || WrappedComponent.name || 'WrappedComponent';
        }
        Decorator.displayName = 'FormBuilderConfiger(' + getDisplayName(WrappedComponent) + ')';
        Decorator.prototype.getWrapperComponent = function () {
          return WrappedComponent;
        };
        return Decorator;
      };
    }
    /**
    * formBuilderConfiger配置转换成FormBuilder的config配置
    * 他们的区别在于type为array类型的时候，formBuilder的children需要再包一层数组
    * children: [] => children: [[]]
    * @param { array } data formBuilderConfiger的配置
    */

  }, {
    key: 'formBuilderConfigAdapter',
    value: function formBuilderConfigAdapter(data) {
      var re = [];
      data && data[0] && data.forEach(function (v, k) {
        //兼容处理
        if (v.data_type && !v.type) {
          v.type = v.data_type;
        }
        //console.debug(v)
        if (v.type === "array") {
          v.type = "table";
        }
        if ((v.type === "table" || v.type === "object") && v.children && v.children) {
          if (v.type === "table") {
            v.children = [v.children];
            v.children.forEach(function (v2, k2) {
              FormBuilderConfiger.formBuilderConfigAdapter(v2);
            });
          }
          if (v.type !== "table") {
            FormBuilderConfiger.formBuilderConfigAdapter(v.children);
          }
        }
        re.push(v);
      });
      return re;
    }

    /**
    * @this { boolean } outerUpdate 是否父组件更新
    * @this { array } config 配置数据this.props.config 
    */

  }]);

  function FormBuilderConfiger(props) {
    _classCallCheck(this, FormBuilderConfiger);

    var _this = _possibleConstructorReturn(this, (FormBuilderConfiger.__proto__ || Object.getPrototypeOf(FormBuilderConfiger)).call(this, props));

    _this.setAddFieldDialogState = function (visible) {
      return function () {
        _this.outerUpdate = false;
        _this.setState({
          addField: visible
        });
      };
    };

    _this.setChangeState = function () {
      var random = util.getUniqueKey();
      _this.outerUpdate = false;
      _this.setState({
        random: random
      });
    };

    _this.addEvent = function (currentData, index) {};

    _this.dataUpEvent = function (currentData, index) {
      return function (e) {
        util.swapArrayItem(currentData, index, index - 1);
        _this.setChangeState();
      };
    };

    _this.dataDownEvent = function (currentData, index) {
      return function (e) {
        util.swapArrayItem(currentData, index, index + 1);
        _this.setChangeState();
      };
    };

    _this.dataDeleteEvent = function (currentData, index) {
      return function (e) {
        currentData.splice(index, 1);
        _this.setChangeState();
      };
    };

    _this.openAddFieldDialogEvent = function (currentData, index) {
      return function (e) {
        //console.debug(currentData)
        _this.setAddFieldDialogState(true)();
        _this.setState({
          currentData: currentData,
          index: index
        });
      };
    };

    _this.state = {};
    //this.config克隆后，跟props.config不同步，props.config还是原始的数据源
    _this.config = _.cloneDeep(_this.props.config);
    return _this;
  }

  _createClass(FormBuilderConfiger, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      //是否是父级组件更新，state的变化是内部更新
      this.outerUpdate = true;
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var flag = shallowCompare(this, nextProps, nextState);
      //一般都是外部props.config改变后触发的。
      //console.debug(flag,this.outerUpdate)
      if (flag && this.outerUpdate) {
        this.config = _.cloneDeep(nextProps.config);
      }
      //console.debug(flag)
      return flag;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var onChange = this.props.onChange;

      if (this.random !== this.state.random) {
        onChange && onChange(this.config, FormBuilderConfiger.formBuilderConfigAdapter(_.cloneDeep(this.config)));
      }
      this.random = this.state.random;
    }
  }, {
    key: 'getTableColumns',
    value: function getTableColumns(currentData) {
      var _this4 = this;

      var _props$hasNoneTableTi = this.props.hasNoneTableTitle,
          hasNoneTableTitle = _props$hasNoneTableTi === undefined ? true : _props$hasNoneTableTi;

      var locale = this.getLocale(localeText, "FormBuilderConfiger");
      var columns = [{
        title: locale.fieldName,
        dataIndex: 'name',
        key: 'name'
      }, {
        title: locale.labelName,
        dataIndex: 'label',
        key: 'label'
      }, {
        title: locale.dataType,
        dataIndex: 'type',
        key: 'type',
        render: function render(text, row, id) {
          if (!text) {
            text = row.type;
          }
          return text;
        }
      }, {
        title: locale.required,
        dataIndex: 'required',
        key: 'required',
        render: function render(value) {
          var text = locale.requiredField;
          value = util.convertStringOfTrueAndFalseToBollean(value);
          if (value) {
            text = locale.requiredField;
          } else {
            text = locale.couldEmpty;
          }
          return text;
        }
      }];
      columns.push({
        title: locale.operation,
        key: 'operation',
        //width: 55,
        render: function render(data, record, id) {
          var read_only = util.convertStringOfTrueAndFalseToBollean(currentData[id].read_only);
          //兼容处理
          if (read_only == "0") {
            read_only = false;
          } else if (read_only == "1") {
            read_only = true;
          }
          var can_not_delete = util.convertStringOfTrueAndFalseToBollean(currentData[id].can_not_delete);return React.createElement(
            'div',
            null,
            !read_only && React.createElement(
              'a',
              {
                href: 'javascript:void(0)',
                className: 'mr10',
                onClick: _this4.openAddFieldDialogEvent(currentData, id)
              },
              React.createElement(Icon, {
                type: 'edit'
              })
            ),
            !can_not_delete && React.createElement(
              'a',
              {
                href: 'javascript:void(0)',
                className: 'mr10',
                onClick: _this4.dataDeleteEvent(currentData, id)
              },
              React.createElement(Icon, {
                type: 'delete'
              })
            ),
            id !== 0 && React.createElement(
              'a',
              {
                href: 'javascript:void(0)',
                className: 'mr10',
                onClick: _this4.dataUpEvent(currentData, id)
              },
              React.createElement(Icon, {
                type: 'arrow-up'
              })
            ),
            id !== currentData.length - 1 && React.createElement(
              'a',
              {
                href: 'javascript:void(0)',
                className: 'mr10',
                onClick: _this4.dataDownEvent(currentData, id)
              },
              React.createElement(Icon, {
                type: 'arrow-down'
              })
            ),
            hasNoneTableTitle && currentData[id].children && React.createElement(
              'a',
              {
                href: 'javascript:void(0)',
                className: 'mr10',
                onClick: _this4.openAddFieldDialogEvent(currentData[id].children)
              },
              _this4.props.fieldAddedOperation && _this4.props.fieldAddedOperation,
              !_this4.props.fieldAddedOperation && React.createElement(Icon, {
                type: 'plus'
              })
            )
          );
        }
      });
      return columns;
    }

    /**
    * 获取Table title
    * @param { string } title 标题 
    * @param { object } currentData 当前列数据   
    * @param { boolean } first 是否是最外层table的标题 
    */

  }, {
    key: 'getTitle',
    value: function getTitle(title, currentData, first) {
      var _this5 = this;

      return function () {
        return React.createElement(
          'div',
          null,
          React.createElement(
            'span',
            null,
            title
          ),
          React.createElement(Icon, {
            type: 'plus-circle',
            className: 'configer-add',
            onClick: _this5.openAddFieldDialogEvent(currentData)
          })
        );
      };
    }
    /**
    * 获取Table组件 (已配置)
    * @param { string } title antd table标题设置
    * @param { array } columns antd table columns
    * @param { array } dataSource antd table dataSource 
    * @param { array } dataSource antd table dataSource 
    * @param { array } currentData 当前表格源数据 
    */

  }, {
    key: 'getTableComponent',
    value: function getTableComponent(title, columns, dataSource, currentData) {
      var obj = {};
      var _props$hasNoneTableTi2 = this.props.hasNoneTableTitle,
          hasNoneTableTitle = _props$hasNoneTableTi2 === undefined ? true : _props$hasNoneTableTi2;

      if (!hasNoneTableTitle) {
        obj.title = this.getTitle(title, currentData);
      }
      return React.createElement(Table, _extends({}, obj, {
        bordered: true,
        pagination: false,
        size: 'middle',
        columns: columns,
        defaultExpandAllRows: true,
        expandedRowRender: function expandedRowRender(record) {
          if (!record.description) {
            return false;
          }
          return React.createElement(
            'div',
            null,
            record.description
          );
        },
        dataSource: dataSource
      }));
    }
  }, {
    key: 'dataSourceAdapter',
    value: function dataSourceAdapter(data) {
      var _this6 = this;

      var re_data = [];
      data.forEach(function (v, k) {
        //兼容处理
        if (v.data_type && !v.type) {
          v.type = v.data_type;
        }
        if (v.type === "array") {
          v.type = "table";
        }
        var description = null;
        if (_.isArray(v.children) && (v.type === "object" || v.type === "table")) {
          var dataSource = _this6.dataSourceAdapter(v.children);
          description = _this6.getTableComponent(
          //<span>&nbsp;</span>,
          v.name + "：" + v.label, _this6.getTableColumns(v.children), dataSource, v.children);
        }
        //console.debug(description)
        re_data.push({
          key: v.key,
          name: v.name,
          label: v.label,
          type: v.type,
          required: v.required,
          description: description
        });
      });
      return re_data;
    }
    //下上切换，上移

    //上下切换，下移


    //删除

  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          config = _props.config,
          onChange = _props.onChange,
          title = _props.title,
          selectSourceDataMap = _props.selectSourceDataMap,
          readOnlyFunction = _props.readOnlyFunction,
          canNotDeleteFunction = _props.canNotDeleteFunction;

      var locale = this.getLocale(localeText, "FormBuilderConfiger");
      //console.debug("render",config);
      //console.debug(this.config)
      var dataSource = this.dataSourceAdapter(this.config || []);
      //对外提供最外层添加窗口
      if (this.context && this.context.formBuilderConfiger) {
        this.context.formBuilderConfiger.openAddFieldDialog = this.openAddFieldDialogEvent(this.config);
      }
      return React.createElement(
        'div',
        { className: 'configer' },
        this.getTableComponent(title || "字段管理", this.getTableColumns(this.config), dataSource, this.config),
        this.state.addField && React.createElement(
          Modal,
          {
            title: this.state.index !== undefined ? locale.edit : locale.add,
            visible: this.state.addField,
            onCancel: this.setAddFieldDialogState(false),
            footer: false
          },
          React.createElement(AddAndUpdateForm, {
            currentData: this.state.currentData,
            index: this.state.index,
            setChangeState: this.setChangeState,
            setAddFieldDialogState: this.setAddFieldDialogState.bind(this),
            selectSourceDataMap: selectSourceDataMap,
            canNotDeleteFunction: canNotDeleteFunction,
            readOnlyFunction: readOnlyFunction
          })
        )
      );
    }
  }]);

  return FormBuilderConfiger;
}(React.Component), _class2.contextTypes = {
  formBuilderConfiger: React.PropTypes.object,
  antLocale: React.PropTypes.object
}, _temp)) || _class;

export default FormBuilderConfiger;