var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import _ from 'lodash';
import moment from 'moment';
import BasicItem from '../BasicItem';
import Input from 'antd/lib/input';
import FormItemComponentDecorator from '../../decorator/FormItemComponent';
import localeDecorator from "../../decorator/Locale";
import localeText from './en_US';

function component(BasicItemComponent) {
  var _class, _class2, _temp;

  var Password = FormItemComponentDecorator(_class = localeDecorator(_class = (_temp = _class2 = function (_React$Component) {
    _inherits(Password, _React$Component);

    function Password() {
      _classCallCheck(this, Password);

      return _possibleConstructorReturn(this, (Password.__proto__ || Object.getPrototypeOf(Password)).apply(this, arguments));
    }

    _createClass(Password, [{
      key: 'render',
      value: function render() {
        var _props = this.props,
            locale = _props.locale,
            key = _props.key,
            rePassword = _props.rePassword,
            _props$onlyLetterAndN = _props.onlyLetterAndNumber,
            onlyLetterAndNumber = _props$onlyLetterAndN === undefined ? true : _props$onlyLetterAndN,
            other = _objectWithoutProperties(_props, ['locale', 'key', 'rePassword', 'onlyLetterAndNumber']);
        //console.debug(this.context)


        locale = this.getLocale(localeText, "FormBuilderPassword");

        other.targetComponent = Input;
        other.type = "password";
        this.propsAdapter(other);
        if (onlyLetterAndNumber) {
          other.rules.push({
            validator: function validator(rule, value, callback, source, options) {
              var errors = [];
              var pass = new RegExp("^[A-Za-z]+[0-9]+[A-Za-z0-9]*|[0-9]+[A-Za-z]+[A-Za-z0-9]*$").test(value);
              if (!pass && value != "") {
                errors.push({
                  message: locale.formatErrorMsg
                });
              }
              callback(errors);
            }
          });
        }
        if (rePassword) {
          var reProps = _.cloneDeep(other);
          reProps.rules = [];
          reProps.min = undefined;
          reProps.max = undefined;
          reProps.value = undefined;
          reProps.storage.value = undefined;
          reProps.formItemProps.label = locale.reLabel, reProps.name = "re-" + reProps.name;
          reProps.rules.push({
            validator: function validator(rule, value, callback, source, options) {
              var errors = [];
              var passwordDom = document.getElementsByName(other.name);
              var password_value = passwordDom[0] && passwordDom[0].value;
              if (password_value !== value) {
                errors.push({
                  message: locale.checkErrorMsg
                });
              }
              callback(errors);
            }
          });
        }
        return React.createElement(
          'span',
          { key: key, className: 'password-con' },
          React.createElement(BasicItemComponent, other),
          rePassword && React.createElement(BasicItemComponent, reProps)
        );
      }
    }]);

    return Password;
  }(React.Component), _class2.propTypes = {
    min: React.PropTypes.oneOfType([React.PropTypes.string, React.PropTypes.number]),
    max: React.PropTypes.oneOfType([React.PropTypes.string, React.PropTypes.number]),
    rePassword: React.PropTypes.bool,
    onlyLetterAndNumber: React.PropTypes.bool
  }, _temp)) || _class) || _class;

  return Password;
}

export default component(BasicItem);