var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PropTypes } from 'react';
import BasicItem from '../BasicItem';
import Select from 'antd/lib/select';
import FormItemComponentDecorator from '../../decorator/FormItemComponent';
import localeDecorator from "../../decorator/Locale";
import localeText from './en_US';

function component(BasicItemComponent) {
  var _class, _class2, _temp;

  var FSelect = FormItemComponentDecorator(_class = localeDecorator(_class = (_temp = _class2 = function (_React$Component) {
    _inherits(FSelect, _React$Component);

    function FSelect(props) {
      _classCallCheck(this, FSelect);

      return _possibleConstructorReturn(this, (FSelect.__proto__ || Object.getPrototypeOf(FSelect)).call(this, props));
    }

    _createClass(FSelect, [{
      key: 'getBooleanOptions',
      value: function getBooleanOptions() {
        var locale = this.getLocale(localeText, "FormBuilderSelect");
        return [{
          label: locale.yes,
          value: "true"
        }, {
          label: locale.no,
          value: "false"
        }];
      }
    }, {
      key: 'renderOptions',
      value: function renderOptions(options) {
        return options && options.map && options.map(function (v, k) {
          return React.createElement(
            Select.Option,
            {
              key: k,
              value: v.value + ""
            },
            v.label || v.text
          );
        });
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var _props = this.props,
            options = _props.options,
            group = _props.group,
            select_target = _props.select_target,
            boolean = _props.boolean,
            other = _objectWithoutProperties(_props, ['options', 'group', 'select_target', 'boolean']);

        var locale = this.getLocale(localeText, "FormBuilderSelect");
        var boolOptions = this.getBooleanOptions();
        other.targetComponent = Select;
        other.type = "select";
        if (other.multiple) {
          other.type = "multiple-select";
        }
        this.propsAdapter(other);
        if (boolean) {
          other.value = other.value + "";
          if (other.storage.value != undefined) {
            other.storage.value += "";
          }
          return (
            //这里的BasicItemComponent相当于
            //<FormItem>
            //  <Select>(AntdSelect)
            //    { children }
            //  </Select>
            //</FormItem>
            React.createElement(
              BasicItemComponent,
              _extends({
                placeholder: locale.placeholder
              }, other),
              this.renderOptions(boolOptions)
            )
          );
        } else if (group) {
          return React.createElement(
            BasicItemComponent,
            _extends({
              placeholder: locale.placeholder
            }, other),
            group.map(function (g_v, g_k) {
              return React.createElement(
                Select.OptGroup,
                {
                  key: g_k,
                  label: g_v.label || ""
                },
                _this2.renderOptions(g_v.options)
              );
            })
          );
        } else if (options) {
          return React.createElement(
            BasicItemComponent,
            _extends({
              placeholder: locale.placeholder
            }, other),
            this.renderOptions(options)
          );
        } else if (select_target) {
          //console.debug(this.context.selectSourceData);
          options = this.context.selectSourceData[select_target];
          return React.createElement(
            BasicItemComponent,
            _extends({
              placeholder: locale.placeholder
            }, other),
            this.renderOptions(options)
          );
        } else {
          return React.createElement(BasicItemComponent, _extends({
            placeholder: locale.placeholder
          }, other));
        }
      }
    }]);

    return FSelect;
  }(React.Component), _class2.contextTypes = Object.assign({}, FormItemComponentDecorator.contextTypes, {
    selectSourceData: React.PropTypes.object
  }), _class2.propTypes = {
    options: React.PropTypes.array,
    group: React.PropTypes.array,
    boolean: React.PropTypes.bool
  }, _temp)) || _class) || _class;

  return FSelect;
}
export default component(BasicItem);