'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _antd = require('antd');

var _PureRender = require('../../decorator/PureRender');

var _PureRender2 = _interopRequireDefault(_PureRender);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 *  ButtonGroup 
 * @prop {string} size size跟ant button group一致 
 * @prop { string } type radio or checkbox 
 * @prop { array } options 选项 
 * @prop { array || string || number } defaultValue 默认值 
 * @prop { array || string || number } value 默认值 
 * @prop {function} onChange 所有按钮选项变化回调函数
 */
var ButtonGroup = (0, _PureRender2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(ButtonGroup, _React$Component);

  function ButtonGroup(props) {
    _classCallCheck(this, ButtonGroup);

    var _this = _possibleConstructorReturn(this, (ButtonGroup.__proto__ || Object.getPrototypeOf(ButtonGroup)).call(this, props));

    _this.onChange = function (value) {
      return function (e) {
        if (_this.props.type === "checkbox") {
          if (_this.checkboxButtonValue && _this.checkboxButtonValue[value]) {
            _this.checkboxButtonValue[value] = false;
          } else {
            _this.checkboxButtonValue[value] = true;
          }
          var values = [];
          for (var k in _this.checkboxButtonValue) {
            if (_this.checkboxButtonValue[k]) {
              values.push(k);
            }
          }
          _this.setState({
            currentValue: values
          });
          _this.props.onChange && _this.props.onChange(values, e);
        } else {
          _this.setState({
            currentValue: value
          });
          _this.props.onChange && _this.props.onChange(value, e);
        }
      };
    };

    _this.state = {};
    return _this;
  }

  _createClass(ButtonGroup, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          _props$size = _props.size,
          size = _props$size === undefined ? "default" : _props$size,
          _props$type = _props.type,
          type = _props$type === undefined ? "radio" : _props$type,
          _props$hightlightType = _props.hightlightType,
          hightlightType = _props$hightlightType === undefined ? "primary" : _props$hightlightType,
          options = _props.options,
          defaultValue = _props.defaultValue,
          value = _props.value,
          otherProps = _objectWithoutProperties(_props, ['size', 'type', 'hightlightType', 'options', 'defaultValue', 'value']);

      return _react2.default.createElement(
        'div',
        otherProps,
        _react2.default.createElement(
          _antd.Button.Group,
          { size: size },
          options && options.map(function (v, k) {
            var btn_props = {};
            btn_props.type = "ghost";
            btn_props.size = size;
            if (v.disabled) {
              btn_props.disabled = true;
            }
            if (type === "radio") {
              if (value) {
                if (v.value === value) {
                  btn_props.type = hightlightType;
                }
              } else if (_this2.state.currentValue) {
                if (v.value === _this2.state.currentValue) {
                  btn_props.type = hightlightType;
                }
              } else if (defaultValue) {
                if (v.value === defaultValue) {
                  btn_props.type = hightlightType;
                }
              }
            } else if (_this2.props.type === "checkbox") {
              if (!_this2.checkboxButtonValue) {
                _this2.checkboxButtonValue = {};
              }
              if (value && _lodash2.default.isArray(value)) {
                value.forEach(function (v, k) {
                  _this2.checkboxButtonValue[v] = true;
                });
                if (value.indexOf(v.value) !== -1) {
                  btn_props.type = hightlightType;
                }
              } else if (_this2.state.currentValue) {
                if (_this2.state.currentValue.indexOf(v.value) !== -1) {
                  btn_props.type = hightlightType;
                }
              } else if (defaultValue && _lodash2.default.isArray(defaultValue)) {
                defaultValue.forEach(function (v, k) {
                  _this2.checkboxButtonValue[v] = true;
                });
                if (defaultValue.indexOf(v.value) !== -1) {
                  btn_props.type = hightlightType;
                }
              } else {
                console.error("value 或 defaultValue 不是数组类型！");
                return false;
              }
            }
            return _react2.default.createElement(
              _antd.Button,
              _extends({}, btn_props, {
                key: k,
                onClick: _this2.onChange(v.value)
              }),
              v.label
            );
          })
        )
      );
    }
  }]);

  return ButtonGroup;
}(_react2.default.Component), _class2.propTypes = {
  size: _react2.default.PropTypes.string,
  type: _react2.default.PropTypes.string,
  options: _react2.default.PropTypes.array,
  defaultValue: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.array, _react2.default.PropTypes.string, _react2.default.PropTypes.number]),
  value: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.array, _react2.default.PropTypes.string, _react2.default.PropTypes.number]),
  onChange: _react2.default.PropTypes.func,
  hightlightType: _react2.default.PropTypes.string
}, _temp)) || _class;

exports.default = ButtonGroup;