'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PureRender = require('../../decorator/PureRender');

var _PureRender2 = _interopRequireDefault(_PureRender);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _button = require('antd/lib/button');

var _button2 = _interopRequireDefault(_button);

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _card = require('antd/lib/card');

var _card2 = _interopRequireDefault(_card);

var _RenderItem = require('../../decorator/RenderItem');

var _RenderItem2 = _interopRequireDefault(_RenderItem);

var _IconGroup = require('../_util/IconGroup');

var _IconGroup2 = _interopRequireDefault(_IconGroup);

var _util = require('../../util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * FormBuilderWidthConfig 
 * 通过配置生成各种表单项，包括嵌套的，理论上可以无限嵌套。
 * @prop { array } config 配置数据
 * @prop { boolean } validateAll 是否验证全部表单项
 */
var FormBuilderWidthConfig = (0, _PureRender2.default)(_class = (0, _RenderItem2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(FormBuilderWidthConfig, _React$Component);

  function FormBuilderWidthConfig(props) {
    _classCallCheck(this, FormBuilderWidthConfig);

    var _this = _possibleConstructorReturn(this, (FormBuilderWidthConfig.__proto__ || Object.getPrototypeOf(FormBuilderWidthConfig)).call(this, props));

    _this.setChangeState = function () {
      var random = _util2.default.getUniqueKey();
      _this.setState({
        random: random
      });
    };

    _this.onIconClick = function (data, index) {
      return function (btn_index) {
        switch (btn_index) {
          case "up":
            _util2.default.swapArrayItem(data, index, index - 1);
            break;
          case "down":
            _util2.default.swapArrayItem(data, index, index + 1);
            break;
          case "delete":
            data.splice(index, 1);
            break;
        }
        //重置name，和repeat_count值
        data.forEach(function (v, k) {
          v.forEach(function (v2, k2) {
            v2.name = v2.origin_name;
            delete v2.origin_name;
            delete v2.repeat_count;
          });
        });
        _this.setChangeState();
        //console.debug(index,data);
      };
    };

    _this.onAddClick = function (data, index) {
      return function (e) {
        var index_data = _lodash2.default.cloneDeep(data[index]);
        index_data.forEach(function (v, k) {
          //改变key值
          v.key = _util2.default.getUniqueKey();
          //还原name
          v.name = v.origin_name;
          //还原repeat_count
          v.repeat_count = null;
          v.storage = {
            value: v.value
          };
        });
        data.splice(index + 1, 0, index_data);
        _this.setChangeState();
      };
    };

    _this.state = {};
    return _this;
  }

  _createClass(FormBuilderWidthConfig, [{
    key: 'configRender',
    value: function configRender(config, name) {
      var _this2 = this;

      return config && config.map(function (v, k) {
        var isElement = true;
        var Element,
            element_props = {};
        var e_name;
        if (name && !v.repeat_count) {
          v.origin_name = v.name;
          //第一次渲染处理
          e_name = name + '[' + v.name + ']';
        } else {
          e_name = v.name;
        }
        //兼容处理
        if (v.data_type && !v.type) {
          v.type = v.data_type;
        }
        if (v.type === "array") {
          v.type = "table";
        }
        var required = _util2.default.convertStringOfTrueAndFalseToBollean(v.required);
        var rules = v.rules || [];
        switch (v.type) {
          case "object":
          case "table":
            isElement = false;
            break;
          default:
            isElement = true;
            if (!v.storage) {
              v.storage = {
                value: v.value
              };
            }
            var type = v.type;
            //console.debug(v)
            element_props = {
              required: required,
              array: _util2.default.convertStringOfTrueAndFalseToBollean(v.array),
              min: parseInt(v.min, 10),
              max: parseInt(v.max, 10),
              name: e_name,
              type: type,
              key: v.key,
              uniqueKey: v.key,
              storage: v.storage,
              value: v.value,
              label: v.label,
              formItemProps: v.formItemProps || {},
              rules: rules,
              disabled: v.disabled,
              readOnly: v.read_only,
              validateAll: _this2.props.validateAll
            };
            v.rules = element_props.rules;
            v.name = element_props.name;
            //重复渲染次数
            if (!v.repeat_count) {
              v.repeat_count = 0;
            }
            v.repeat_count++;
            switch (v.type) {
              case "string":
                type = "text";
                break;
              case "dropdown":
                type = "select";
                //字段配置时选择的select数据源
                element_props.select_target = v.select_target;
                break;
              case "boolean":
                element_props.boolean = true;
                type = "select";
                break;
            }
            //console.debug(v);
            Element = _this2.getFormItemComponentByType(type);
        }
        var temp_name = e_name;
        return _react2.default.createElement(
          'div',
          { key: k },
          !isElement && v.type === "table" && v.children && v.children[0] && v.children[0][0] && _react2.default.createElement(
            _card2.default,
            { title: v.label, className: 'mb10 array-card-con' },
            v.children.map(function (v2, k2) {
              var array_title;
              var otherProps = {};
              if (v.children.length !== 1) {
                array_title = _react2.default.createElement(_IconGroup2.default, {
                  action: {
                    up_action: true,
                    down_action: true,
                    delete_action: true
                  },
                  index: k2,
                  data: v.children,
                  onIconClick: _this2.onIconClick(v.children, k2)
                });
                otherProps.title = array_title;
              }
              e_name = temp_name + '[' + k2 + ']';
              return _react2.default.createElement(
                'div',
                {
                  key: v2[0].key
                },
                _react2.default.createElement(
                  _card2.default,
                  _extends({}, otherProps, {
                    className: 'array-card mb10'
                  }),
                  _this2.configRender(v2, e_name)
                ),
                k2 === v.children.length - 1 && _react2.default.createElement(
                  _button2.default,
                  {
                    className: 'builder-add-btn',
                    type: 'primary',
                    onClick: _this2.onAddClick(v.children, k2)
                  },
                  _react2.default.createElement(_icon2.default, { type: 'plus' })
                )
              );
            })
          ),
          !isElement && v.type !== "table" && v.children && v.children[0] && _react2.default.createElement(
            _card2.default,
            { title: v.label, className: 'mb10 not-array-card-con' },
            v.type !== "table" && _this2.configRender(v.children, e_name)
          ),
          isElement && !v.children && _react2.default.createElement(Element, element_props)
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          config = _props.config,
          onChange = _props.onChange,
          other = _objectWithoutProperties(_props, ['className', 'config', 'onChange']);

      other.className = className + " builder-without-form-con";
      return _react2.default.createElement(
        'div',
        null,
        this.configRender(config)
      );
    }
  }]);

  return FormBuilderWidthConfig;
}(_react2.default.Component), _class2.propTypes = {
  config: _react2.default.PropTypes.array.isRequired,
  validateAll: _react2.default.PropTypes.bool
}, _temp)) || _class) || _class;

exports.default = FormBuilderWidthConfig;