'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _antd = require('antd');

var _FormBuilder = require('../../FormBuilder');

var _FormBuilder2 = _interopRequireDefault(_FormBuilder);

var _Input = require('../../Input');

var _Input2 = _interopRequireDefault(_Input);

var _InputNumber = require('../../InputNumber');

var _InputNumber2 = _interopRequireDefault(_InputNumber);

var _Select = require('../../Select');

var _Select2 = _interopRequireDefault(_Select);

var _util = require('../../../util');

var _util2 = _interopRequireDefault(_util);

var _en_US = require('../en_US');

var _en_US2 = _interopRequireDefault(_en_US);

var _Locale = require('../../../decorator/Locale');

var _Locale2 = _interopRequireDefault(_Locale);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormItem = _antd.Form.Item;

var AddAndUpdateForm = (_dec = _FormBuilder2.default.create(), _dec(_class = (0, _Locale2.default)(_class = (_temp = _class2 = function (_React$Component) {
  _inherits(AddAndUpdateForm, _React$Component);

  function AddAndUpdateForm(props) {
    _classCallCheck(this, AddAndUpdateForm);

    var _this = _possibleConstructorReturn(this, (AddAndUpdateForm.__proto__ || Object.getPrototypeOf(AddAndUpdateForm)).call(this, props));

    _initialiseProps.call(_this);

    var currentData = props.currentData,
        index = props.index;

    _this.state = {};
    if (index !== undefined) {
      //index不为undefined，说明是编辑，否则是添加
      _this.isEdited = true;
    } else {
      _this.isEdited = false;
    }
    return _this;
  }

  _createClass(AddAndUpdateForm, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          currentData = _props.currentData,
          index = _props.index;

      if (this.isEdited) {
        var data = currentData[index];
        if (data.type === "array") {
          data.type = "table";
        }
        var obj = {
          name: data.name,
          label: data.label,
          type: data.type
        };
        if (data.type === "boolean") {
          obj.value = !!_util2.default.convertStringOfTrueAndFalseToBollean(data.value) + "";
        } else if (data.value) {
          obj.value = data.value;
        }
        if (data.select_target) {
          obj.select_target = data.select_target;
        }
        if (data.required !== undefined) {
          obj.required = !!_util2.default.convertStringOfTrueAndFalseToBollean(data.required) + "";
        }
        if (data.min) {
          obj.min = data.min;
        }
        if (data.max) {
          obj.max = data.max;
        }
        if (data.array !== undefined) {
          obj.array = !!_util2.default.convertStringOfTrueAndFalseToBollean(data.array) + "";
        }
        if (data.read_only !== undefined) {
          obj.read_only = !!_util2.default.convertStringOfTrueAndFalseToBollean(data.read_only) + "";
        }
        if (data.can_not_delete !== undefined) {
          obj.can_not_delete = !!_util2.default.convertStringOfTrueAndFalseToBollean(data.can_not_delete) + "";
        }
        //console.debug(obj)
        this.props.formBuilder && this.props.formBuilder.setFieldsValue(obj);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          selectSourceDataMap = _props2.selectSourceDataMap,
          currentData = _props2.currentData,
          index = _props2.index,
          canNotDeleteFunction = _props2.canNotDeleteFunction,
          readOnlyFunction = _props2.readOnlyFunction;

      var formItemLayout = {
        labelCol: { span: 5 },
        wrapperCol: { span: 17 }
      };
      var type = this.state.type || currentData[index] && currentData[index].type;
      if (type === "array") {
        type = "table";
      }
      //console.debug(type);
      var locale = this.getLocale(_en_US2.default, "FormBuilderConfiger");
      return _react2.default.createElement(
        _FormBuilder2.default,
        _extends({
          size: 'large',
          onSubmit: this.submitEvent
        }, formItemLayout),
        _react2.default.createElement(_Input2.default, {
          label: locale.fieldName,
          name: 'name',
          required: true,
          placeholder: locale.filedNameRequiredMessage
        }),
        _react2.default.createElement(_Input2.default, {
          label: locale.labelName,
          name: 'label',
          required: true,
          placeholder: locale.labelNameRequiredMessage
        }),
        _react2.default.createElement(_Select2.default, {
          label: locale.dataType,
          name: 'type',
          required: true,
          options: _util2.default.dataType,
          placeholder: locale.dataTypeReqiuredMessage,
          onChange: this.onTypeChange
        }),
        type != undefined && type !== "object" && type !== "table" && type !== "dropdown" && type !== "boolean" && _react2.default.createElement(_Select2.default, {
          name: 'array',
          label: locale.isArray,
          placeholder: locale.please,
          value: false,
          boolean: true
        }),
        type === "string" && _react2.default.createElement(
          'span',
          null,
          _react2.default.createElement(_InputNumber2.default, {
            name: 'min',
            type: 'integer',
            label: locale.minLength,
            placeholder: locale.minLengthPlaceholder
          }),
          _react2.default.createElement(_InputNumber2.default, {
            name: 'max',
            type: 'integer',
            label: locale.maxLength,
            placeholder: locale.maxLengthPlaceholder
          })
        ),
        type != undefined && type !== "object" && type !== "table" && type !== "dropdown" && type !== "boolean" && _react2.default.createElement(_Input2.default, {
          name: 'value',
          label: locale.defaultValue,
          placeholder: locale.defaultValuePlaceholder
        }),
        type === "boolean" && _react2.default.createElement(_Select2.default, {
          name: 'value',
          label: locale.defaultValue,
          placeholder: locale.please,
          boolean: true,
          value: false
        }),
        type === "dropdown" && _react2.default.createElement(_Select2.default, {
          required: true,
          name: 'select_target',
          label: locale.listTargetLabel,
          placeholder: locale.listTargetPlease,
          options: selectSourceDataMap
        }),
        _react2.default.createElement(_Select2.default, {
          required: true,
          name: 'required',
          label: locale.required,
          placeholder: locale.requiredPlease,
          boolean: true,
          value: true
        }),
        readOnlyFunction && _react2.default.createElement(_Select2.default, {
          name: 'read_only',
          label: locale.readOnly,
          placeholder: locale.readOnlyPlease,
          boolean: true,
          value: false
        }),
        canNotDeleteFunction && _react2.default.createElement(_Select2.default, {
          name: 'can_not_delete',
          label: locale.cannotDelete,
          placeholder: locale.cannotDeletePlease,
          boolean: true,
          value: false
        }),
        _react2.default.createElement(
          FormItem,
          _extends({}, formItemLayout, {
            className: 'none-label-con mt20',
            label: ' ',
            hasFeedback: true
          }),
          _react2.default.createElement(
            _antd.Button,
            {
              className: 'fr',
              type: 'primary',
              size: 'large',
              htmlType: 'submit'
            },
            locale.confirm
          ),
          _react2.default.createElement(
            _antd.Button,
            {
              className: 'fr mr10',
              type: 'default',
              size: 'large',
              onClick: function onClick(e) {
                _this2.props.setAddFieldDialogState(false)(e);
              }
            },
            locale.cancel
          )
        )
      );
    }
  }]);

  return AddAndUpdateForm;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.onTypeChange = function (value) {
    _this3.setState({
      type: value
    });
  };

  this.submitEvent = function (e) {
    e.preventDefault();
    _this3.props.formBuilder.validateFields(function (err, values) {
      //console.debug(values);
      if (err) {
        console.log(err);
        return;
      }
      var _props3 = _this3.props,
          currentData = _props3.currentData,
          index = _props3.index;
      //console.debug(values);
      //array类型兼容处理

      if (values.type === "array") {
        values.type = "table";
      }
      switch (values.type) {
        case "object":
        case "table":
          if (!_this3.isEdited) {
            values.children = [];
          }
          break;
      }
      if (_this3.isEdited) {
        values.key = currentData[index].key;
        if (values.type === "table" || values.type === "object") {
          values.children = currentData[index].children || [];
        };
        currentData[index] = values;
      } else {
        values.key = _util2.default.getUniqueKey();
        currentData.push(values);
      }
      _this3.props.setChangeState();
      _this3.props.setAddFieldDialogState(false)();
    });
  };
}, _temp)) || _class) || _class);
exports.default = AddAndUpdateForm;