'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _FormItemComponent = require('../../decorator/FormItemComponent');

var _FormItemComponent2 = _interopRequireDefault(_FormItemComponent);

var _Locale = require('../../decorator/Locale');

var _Locale2 = _interopRequireDefault(_Locale);

var _BasicItem = require('../BasicItem');

var _BasicItem2 = _interopRequireDefault(_BasicItem);

var _en_US = require('./en_US');

var _en_US2 = _interopRequireDefault(_en_US);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function component(BasicItemComponent) {
  var _class, _class2, _temp;

  var FInput = (0, _FormItemComponent2.default)(_class = (0, _Locale2.default)(_class = (_temp = _class2 = function (_React$Component) {
    _inherits(FInput, _React$Component);

    function FInput(props) {
      _classCallCheck(this, FInput);

      return _possibleConstructorReturn(this, (FInput.__proto__ || Object.getPrototypeOf(FInput)).call(this, props));
    }

    _createClass(FInput, [{
      key: 'getInfoObject',


      //定义rule,type等信息 
      value: function getInfoObject(type) {
        var locale = this.getLocale(_en_US2.default, "FormBuilderInput");
        var rules = FInput.getRules(locale);
        switch (type) {
          case "email":
            return {
              rules: rules.email,
              type: "text"
            };
          case "url":
            return {
              rules: rules.url,
              type: "text"
            };
          case "phone":
            return {
              rules: rules.phone,
              type: "text"
            };
          case "textarea":
            return {
              type: "textarea"
            };
          case "hidden":
            return {
              type: "hidden"
            };
          default:
            return {
              type: "text",
              rules: []
            };
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var _props = this.props,
            type = _props.type,
            _props$rules = _props.rules,
            rules = _props$rules === undefined ? [] : _props$rules,
            other = _objectWithoutProperties(_props, ['type', 'rules']);

        var infoObject = this.getInfoObject(type);
        var temp_rules = [];
        Array.prototype.push.apply(temp_rules, rules);
        Array.prototype.push.apply(temp_rules, infoObject.rules || []);
        other.rules = temp_rules;
        other.type = infoObject.type;
        other.targetComponent = _input2.default;
        this.propsAdapter(other);
        return _react2.default.createElement(BasicItemComponent, other);
      }
    }], [{
      key: 'getRules',


      //其他地方也可以访问这个rules，测试就要用到
      value: function getRules(replaceLocale) {
        var locale = replaceLocale;
        return {
          email: [{
            type: "email",
            message: locale.emailErrorMsg
          }],
          url: [{
            type: "url",
            message: locale.urlErrorMsg
          }],
          phone: [{
            validator: function validator(rule, value, callback, source, options) {
              var reg = /^(13[0-9]|14[0-9]|15[0-9]|17[0-9]|18[0-9])\d{8}$/i;
              var errors = [];
              if (!reg.test(value) && value != "") {
                errors.push({
                  message: locale.phoneErrorMsg
                });
              }
              callback(errors);
            }
          }]
        };
      }
    }]);

    return FInput;
  }(_react2.default.Component), _class2.propTypes = {
    min: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number]),
    max: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number]),
    onlyLetter: _react2.default.PropTypes.bool
  }, _temp)) || _class) || _class;

  return FInput;
}

var Item = component(_BasicItem2.default);

exports.default = Item;