'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _util = require('../util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  size: _react2.default.PropTypes.string,
  hasFeedback: _react2.default.PropTypes.bool,
  labelCol: _react2.default.PropTypes.object,
  wrapperCol: _react2.default.PropTypes.object,
  config: _react2.default.PropTypes.array
};

var childContextTypes = {
  size: _react2.default.PropTypes.string,
  hasFeedback: _react2.default.PropTypes.bool,
  labelCol: _react2.default.PropTypes.object,
  wrapperCol: _react2.default.PropTypes.object,
  inline: _react2.default.PropTypes.bool,
  setFieldValueFunc: _react2.default.PropTypes.object,
  itemsValidateFunc: _react2.default.PropTypes.object,
  selectSourceData: _react2.default.PropTypes.object
};

var contextTypes = {
  formBuilder: _react2.default.PropTypes.object
};
function create() {
  var _class, _temp;

  var Decorator = (_temp = _class = function (_React$Component) {
    _inherits(Decorator, _React$Component);

    function Decorator(props) {
      _classCallCheck(this, Decorator);

      var _this = _possibleConstructorReturn(this, (Decorator.__proto__ || Object.getPrototypeOf(Decorator)).call(this, props));

      _this.formBuilder = {};
      return _this;
    }

    _createClass(Decorator, [{
      key: 'getChildContext',
      value: function getChildContext() {
        return {
          formBuilder: this.formBuilder
        };
      }
    }, {
      key: 'render',
      value: function render() {
        var WrapperComponent = this.getWrapperComponent();
        return _react2.default.createElement(WrapperComponent, _extends({}, this.props, {
          formBuilder: this.formBuilder
        }));
      }
    }]);

    return Decorator;
  }(_react2.default.Component), _class.childContextTypes = {
    formBuilder: _react.PropTypes.object.isRequired
  }, _temp);

  return function (WrappedComponent) {
    function getDisplayName(WrappedComponent) {
      return WrappedComponent.displayName || WrappedComponent.name || 'WrappedComponent';
    }
    Decorator.displayName = 'FormBuilder(' + getDisplayName(WrappedComponent) + ')';
    Decorator.prototype.getWrapperComponent = function () {
      return WrappedComponent;
    };
    return Decorator;
  };
}
/**
* formBuilderConfig value赋值（根据FormBuilder的表单结构所存储的值来赋值） 
* @param { array } formBuilderConfig FormBuilder组件的props.config
* @param { object } data  FormBuilder的表单结构所存储的值
*/
function valuesToConfig(formBuilderConfig, data) {
  formBuilderConfig.forEach(function (v, k) {
    if (v.type === "array") {
      v.type = "table";
    }
    if (!v.key) {
      v.key = _util2.default.getUniqueKey();
    }
    if (!v.children) {
      if (data[v.name] !== undefined) {
        v.value = data[v.name];
      }
    } else if (v.type === "object" && v.children) {
      if (data[v.name] !== undefined) {
        valuesToConfig(v.children, data[v.name]);
      }
    } else if (v.type === "table" && v.children) {
      if (data[v.name] !== undefined) {
        var arr = [];
        var temp_data = data[v.name];
        temp_data.forEach(function (v2, k2) {
          var temp = _lodash2.default.cloneDeep(v.children[0]);
          //处理key值
          temp.forEach(function (v3, k3) {
            v3.key = _util2.default.getUniqueKey();
          });
          valuesToConfig(temp, v2);
          arr.push(temp);
          //console.debug(v)
        });
        v.children = arr;
      }
    }
  });
  return formBuilderConfig;
}

function getChildContext() {
  return {
    size: this.props.size,
    hasFeedback: this.props.hasFeedback,
    labelCol: this.props.labelCol,
    wrapperCol: this.props.wrapperCol,
    inline: this.props.inline,
    setFieldValueFunc: this.setFieldValueFunc,
    itemsValidateFunc: this.itemsValidateFunc,
    selectSourceData: this.props.selectSourceData
  };
}

function builderDecorator(component) {
  component.propTypes = propTypes;
  component.childContextTypes = childContextTypes;
  component.contextTypes = contextTypes;
  component.create = create;
  component.valuesToConfig = valuesToConfig;
  component.prototype.getChildContext = getChildContext;
}
exports.default = builderDecorator;