'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function renderIconGroup(action, index, data) {
  var _this = this;

  var group;
  if (action) {
    if (_lodash2.default.isBoolean(action)) {
      action = {
        up_action: true,
        down_action: true,
        add_action: true,
        delete_action: true
      };
    }
    var upIcon = _react2.default.createElement(_antd.Icon, {
      className: 'mr10',
      type: 'arrow-up',
      onClick: function onClick(e) {
        _this.onButtonChange(data, index)("up");
      }
    });
    var downIcon = _react2.default.createElement(_antd.Icon, {
      className: 'mr10',
      type: 'arrow-down',
      onClick: function onClick(e) {
        _this.onButtonChange(data, index)("down");
      }
    });
    var addIcon = _react2.default.createElement(_antd.Icon, {
      className: 'mr10',
      type: 'plus',
      onClick: function onClick(e) {
        _this.onButtonChange(data, index)("add");
      }
    });
    var deleteIcon = _react2.default.createElement(_antd.Icon, {
      className: 'mr10',
      type: 'delete',
      onClick: function onClick(e) {
        _this.onButtonChange(data, index)("delete");
      }
    });

    if (!action.up_action) {
      upIcon = false;
    }
    if (!action.down_action) {
      downIcon = false;
    }
    if (!action.add_action) {
      addIcon = false;
    }
    if (!action.delete_action) {
      deleteIcon = false;
    }
    if (index === 0) {
      upIcon = false;
    }
    if (index === data.length - 1) {
      downIcon = false;
    }
    if (data.length - 1 === 0) {
      deleteIcon = false;
    }
    group = _react2.default.createElement(
      'span',
      { className: 'icon-group-con' },
      upIcon,
      downIcon,
      addIcon,
      deleteIcon
    );
  }
  return group;
}

function iconGroupDecorator(component) {
  component.prototype.renderIconGroup = renderIconGroup;
}
exports.default = iconGroupDecorator;