'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _ButtonGroup = require('../components/Button/ButtonGroup');

var _ButtonGroup2 = _interopRequireDefault(_ButtonGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
* 获取处理后的ButtonGroup组件
* @param { object || boolean } action 是否操作 
* @param { int } index 当前数组中form item 索引，所有操作都是作用于当前form item
* @param { array } data 当前form item 数据的父级数据 
*/
function buttonGroupAdapter(action, index, data) {
  var buttonGroup;
  if (action) {
    if (_lodash2.default.isBoolean(action)) {
      action = {
        up_action: true,
        down_action: true,
        add_action: true,
        delete_action: true
      };
    }
    var options = [];
    var obj;
    if (action.up_action) {
      obj = {
        value: "up",
        label: _react2.default.createElement(_icon2.default, { type: 'arrow-up' })
      };
      if (index === 0) {
        obj.disabled = true;
      }
      options.push(obj);
    }
    if (action.up_action) {
      obj = {
        value: "down",
        label: _react2.default.createElement(_icon2.default, { type: 'arrow-down' })
      };
      if (index === data.length - 1) {
        obj.disabled = true;
      }
      options.push(obj);
    }
    if (action.add_action) {
      obj = {
        value: "add",
        label: _react2.default.createElement(_icon2.default, { type: 'plus' })
      };
      options.push(obj);
    }
    if (action.delete_action) {
      obj = {
        value: "delete",
        label: _react2.default.createElement(_icon2.default, { type: 'delete' })
      };
      if (data.length - 1 === 0) {
        obj.disabled = true;
      }
      options.push(obj);
    }
    //console.debug(this.context)
    buttonGroup = _react2.default.createElement(_ButtonGroup2.default, {
      options: options,
      onChange: this.onButtonChange && this.onButtonChange(data, index),
      value: []
    });
  }
  return buttonGroup;
}

function ItemButtonGroupDecorator(component) {
  component.prototype.buttonGroupAdapter = buttonGroupAdapter;
}
exports.default = ItemButtonGroupDecorator;