'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _Input = require('../components/Input');

var _Input2 = _interopRequireDefault(_Input);

var _InputNumber = require('../components/InputNumber');

var _InputNumber2 = _interopRequireDefault(_InputNumber);

var _Select = require('../components/Select');

var _Select2 = _interopRequireDefault(_Select);

var _TimePicker = require('../components/TimePicker');

var _TimePicker2 = _interopRequireDefault(_TimePicker);

var _DatePicker = require('../components/DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

var _MonthPicker = require('../components/MonthPicker');

var _MonthPicker2 = _interopRequireDefault(_MonthPicker);

var _RangePicker = require('../components/RangePicker');

var _RangePicker2 = _interopRequireDefault(_RangePicker);

var _CheckboxGroup = require('../components/CheckboxGroup');

var _CheckboxGroup2 = _interopRequireDefault(_CheckboxGroup);

var _RadioGroup = require('../components/RadioGroup');

var _RadioGroup2 = _interopRequireDefault(_RadioGroup);

var _Password = require('../components/Password');

var _Password2 = _interopRequireDefault(_Password);

var _Cascader = require('../components/Cascader');

var _Cascader2 = _interopRequireDefault(_Cascader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getFormItemComponentByType(type) {
  var Element;
  switch (type) {
    case "hidden":
    case "text":
    case "email":
    case "textarea":
    case "url":
      Element = _Input2.default;
      break;
    case "number":
    case "float":
    case "integer":
      Element = _InputNumber2.default;
      break;
    case "select":
      Element = _Select2.default;
      break;
    case "time":
      Element = _TimePicker2.default;
    case "time-picker":
      Element = _TimePicker2.default;
      break;
    case "date":
    case "date-picker":
      Element = _DatePicker2.default;
      break;
    case "month-picker":
    case "month":
      Element = _MonthPicker2.default;
      break;
    case "range":
    case "range-picker":
      Element = _RangePicker2.default;
      break;
    case "checkbox-group":
      Element = _CheckboxGroup2.default;
      break;
    case "radio-group":
      Element = _RadioGroup2.default;
      break;
    case "password":
      Element = _Password2.default;
      break;
    case "cascader":
      Element = _Cascader2.default;
      break;
    default:
      Element = _Input2.default;
  }
  return Element;
}

function renderItemDecorator(component) {
  component.prototype.getFormItemComponentByType = getFormItemComponentByType;
  return component;
}
exports.default = renderItemDecorator;